package example.servlet;

import example.entity.UserCredential;

import javax.annotation.Resource;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.PersistenceUnit;
import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.transaction.UserTransaction;
import javax.naming.Context;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Hashtable;

public class RegistrationServlet extends HttpServlet {

    // This injects the default entity manager factory
    @PersistenceUnit(unitName = "pujavaee")
    private EntityManagerFactory emf;

    // This injects a user transaction object.
    @Resource
    private UserTransaction utx;

    public void service (HttpServletRequest req , HttpServletResponse resp)
                    throws ServletException, IOException {

        // create an entity manager in service() so that only
        // this thread uses it.
        // More over, we create EM after utx.begin(), so that we don't
        // have to call em.joinTransaction().
        EntityManager em = emf.createEntityManager();

        try {
            resp.setContentType("text/html");
            PrintWriter out = resp.getWriter();
            out.println("<HTML> <HEAD> <TITLE>New User Registartion " +
                        "</TITLE> </HEAD> <BODY BGCOLOR=white>");

            String name = req.getParameter("name");
            String password = req.getParameter("password");

            UserCredential credential = new UserCredential(name, password);

            // em.persist makes the new object as persistent and managed.
            utx.begin();
            em.joinTransaction();
            em.persist(credential);
            utx.commit();

            out.println("Successfully created the new user. " +
                            "Click <A HREF=\"query.html\"> here </A> to query for data.");
            out.println("</BODY> </HTML> ");

        } catch (Exception e) {
//            try {
//                utx.rollback();
//            } catch (Exception ee) {
//                // log the exception and continue
//            }
            throw new ServletException(e);
        } finally {
            // close the em so that provider can release resources.
            em.close();
        }
    }

    public void  init( ServletConfig config) throws ServletException {
        super.init(config);

/*
        EntityManagerImpl eclipselinkem = (EntityManagerImpl)emf.createEntityManager().getDelegate();
        ServerSession serverSession = eclipselinkem.getServerSession();
        eclipselinkem.close();

		RemoteCommandManager rcm = new RemoteCommandManager((CommandProcessor)serverSession);
		Hashtable properties = new Hashtable(2);
		properties.put(Context.PROVIDER_URL,"iiop://localhost:33700");
		properties.put(Context.INITIAL_CONTEXT_FACTORY,"com.sun.appserv.naming.S1ASCtxFactory");

		rcm.getTransportManager();
        JMSTopicTransportManager tm = new JMSTopicTransportManager(rcm);
        tm.setTopicHostUrl("mqtcp://localhost:37676");
		tm.setLocalContextProperties(properties);
		tm.setRemoteContextProperties(properties);
		tm.setTopicName("jms/EclipseLinkTopic");
		tm.setTopicConnectionFactoryName("jms/EclipseLinkTopicConnectionFactory");
		tm.setUserName("guest");
		tm.setPassword("guest");

		rcm.setTransportManager(tm);
		((DatabaseSession)serverSession).setCommandManager(rcm);
        rcm.initialize();
        //((DatabaseSession)serverSession).setShouldPropagateChanges(true);
*/
    }

}
